/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.region;

import de.steamwar.bausystem.region.Region;
import de.steamwar.bausystem.region.RegionUtils;
import de.steamwar.bausystem.region.flags.Flag;
import de.steamwar.bausystem.region.flags.WaterDestroyMode;
import de.steamwar.command.SWCommand;
import de.steamwar.linkage.Linked;
import org.bukkit.entity.Player;

@Linked
public class WaterDestroyCommand extends SWCommand {
    public WaterDestroyCommand() {
        super("waterdestroy");
    }

    private String getEnableMessage() {
        return "REGION_WATER_ENABLED";
    }

    private String getDisableMessage() {
        return "REGION_WATER_DISABLED";
    }

    @Register(description = "REGION_WATER_HELP")
    public void toggleCommand(@Validator Player p) {
        Region region = Region.getRegion(p.getLocation());

        if (toggle(region)) {
            RegionUtils.actionBar(region, getEnableMessage());
        } else {
            RegionUtils.actionBar(region, getDisableMessage());
        }
    }

    private boolean toggle(Region region) {
        if (region.getRegionData().get(Flag.WATER_DESTROY).isWithDefault(WaterDestroyMode.DENY)) {
            region.getRegionData().set(Flag.WATER_DESTROY, WaterDestroyMode.ALLOW);
            return false;
        } else {
            region.getRegionData().set(Flag.WATER_DESTROY, WaterDestroyMode.DENY);
            return true;
        }
    }
}
